(add-load-path "./")
(use gauche.net) 
(use controller) 

(define (web-server)
  (let1 server-socket (make-server-socket 'inet 8080 :reuse-addr? #t)
    (guard (e (else (socket-close server-socket) (report-error e)))
     (while #t
       (let* ((client-socket (socket-accept server-socket))
	      (request (get-request (socket-input-port client-socket))))
	 (put-response 
	  (dispatch request)
	  (socket-output-port client-socket))
	 (socket-close client-socket))))))

 (define (get-request in-port)
   (cond ((rxmatch #/^GET\s+(\S+)\s/ (read-line in-port)) => (lambda (m) (m 1)))
         (else "")))
 
 (define (put-response content out-port)
   (display "HTTP/1.1 200 OK\r\n" out-port) 
   (display "Content-Type: text/html; charset=utf-8\r\n" out-port) 
   (display #`"Content-Length: ,(string-size content)\r\n" out-port) 
   (display "\r\n" out-port) 
   (display content out-port))
 
(web-server)
